unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.Grids, Vcl.DBGrids, Data.DB,
  Data.Win.ADODB, Vcl.StdCtrls, Vcl.ComCtrls, Vcl.ExtCtrls, KAExport;

type
  TForm1 = class(TForm)
    ADOConnection1: TADOConnection;
    ADOTable1: TADOTable;
    DataSource1: TDataSource;
    SaveDialog1: TSaveDialog;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    Panel1: TPanel;
    ListView1: TListView;
    StringGrid1: TStringGrid;
    DBGrid1: TDBGrid;
    KAExport1: TKAExport;
    Panel2: TPanel;
    ProgressBar1: TProgressBar;
    Panel3: TPanel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button10: TButton;
    Button11: TButton;
    Panel4: TPanel;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Panel5: TPanel;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure KAExport1ExportProgress(Sender: TObject; CurrentRecord,
      RecordCount: Integer);
    procedure KAExport1ValidateHeaders(Sender: TObject; ColumnNumber: Integer;
      var Header: string);
    procedure KAExport1ValidateValue(Sender: TObject; CurrentRecord,
      FieldNumber: Integer; var Value: OleVariant);
    procedure KAExport1HeaderError(Sender: TObject; ColumnNumber: Integer;
      var Header: string);
    procedure KAExport1TableNameError(Sender: TObject; var TableName: string);
    procedure KAExport1ExportRow(Sender: TObject; CurrentRecord: Integer;
      var Export: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}


//******************************************************************************
//     Export entire DbGrid/DataSet
//******************************************************************************
procedure TForm1.Button1Click(Sender: TObject);
begin
  KAExport1.TableName          := 'Employees';
  KAExport1.DataSource         := DBGrid1;
  KAExport1.ExportFromCurrent  := False;
  KAExport1.ExportSelected     := False;
  KAExport1.OverwriteTarget    := True;

  PageControl1.ActivePageIndex := 0;
  SaveDialog1.Filter           := KAExport1.FileFormatsList;
  SaveDialog1.DefaultExt       := 'xls';
  if SaveDialog1.Execute then
     Begin
       KAExport1.ConfigureFromFileName(SaveDialog1.FileName);
       if KAExport1.OverwriteTarget then DeleteFile(SaveDialog1.FileName);
       KAExport1.Activate := True;
     End;
end;


//******************************************************************************
//     Export DbGrid/DataSet starting from current record
//******************************************************************************
procedure TForm1.Button2Click(Sender: TObject);
begin
  KAExport1.TableName          := 'Employees';
  KAExport1.DataSource         := DBGrid1;
  KAExport1.ExportFromCurrent  := True;
  KAExport1.ExportSelected     := False;
  KAExport1.OverwriteTarget    := True;

  PageControl1.ActivePageIndex := 0;
  SaveDialog1.Filter           := KAExport1.FileFormatsList;
  SaveDialog1.DefaultExt       := 'xls';
  if SaveDialog1.Execute then
     Begin
       KAExport1.ConfigureFromFileName(SaveDialog1.FileName);
       if KAExport1.OverwriteTarget then DeleteFile(SaveDialog1.FileName);
       KAExport1.Activate := True;
     End;
end;

//******************************************************************************
//     Export DbGrid selected rows only
//******************************************************************************
procedure TForm1.Button3Click(Sender: TObject);
begin
  KAExport1.TableName          := 'Employees';
  KAExport1.DataSource         := DBGrid1;
  KAExport1.ExportFromCurrent  := False;
  KAExport1.ExportSelected     := True;
  KAExport1.OverwriteTarget    := True;

  PageControl1.ActivePageIndex := 0;
  SaveDialog1.Filter           := KAExport1.FileFormatsList;
  SaveDialog1.DefaultExt       := 'xls';
  if SaveDialog1.Execute then
     Begin
       KAExport1.ConfigureFromFileName(SaveDialog1.FileName);
       if KAExport1.OverwriteTarget then DeleteFile(SaveDialog1.FileName);
       KAExport1.Activate := True;
     End;
end;

//******************************************************************************
//     Export DBGrid/Dataset/Etc Data in to two Excel sheets in one file
//******************************************************************************
procedure TForm1.Button10Click(Sender: TObject);
begin
  KAExport1.TableName          := 'Employees';
  KAExport1.DataSource         := DBGrid1;
  KAExport1.ExportFromCurrent  := False;
  KAExport1.ExportSelected     := False;
  KAExport1.OverwriteTarget    := True;

  PageControl1.ActivePageIndex := 0;
  SaveDialog1.Filter           := KAExport1.FileFormatsList;
  SaveDialog1.DefaultExt       := 'xls';
  if SaveDialog1.Execute then
     Begin
       KAExport1.ConfigureFromFileName(ChangeFileExt(SaveDialog1.FileName,'.xls'));
       if KAExport1.OverwriteTarget then DeleteFile(SaveDialog1.FileName);
       KAExport1.Activate := True;
       //***********************************************************************
       KAExport1.TableName          := 'Employees2';
       KAExport1.Activate           := True;
       //***********************************************************************
     End;
end;

//******************************************************************************
//     Export DBGrid/Dataset/Etc Data twice to same Excel sheet
//******************************************************************************
procedure TForm1.Button11Click(Sender: TObject);
begin
  KAExport1.TableName          := 'Employees';
  KAExport1.DataSource         := DBGrid1;
  KAExport1.ExportFromCurrent  := False;
  KAExport1.ExportSelected     := False;
  KAExport1.OverwriteTarget    := True;

  PageControl1.ActivePageIndex := 0;
  SaveDialog1.Filter           := KAExport1.FileFormatsList;
  SaveDialog1.DefaultExt       := 'xls';
  if SaveDialog1.Execute then
     Begin
       KAExport1.ConfigureFromFileName(ChangeFileExt(SaveDialog1.FileName,'.xls'));
       if KAExport1.OverwriteTarget then DeleteFile(SaveDialog1.FileName);
       KAExport1.Activate := True;
       //***********************************************************************
       KAExport1.OverwriteTarget    := False;
       KAExport1.Activate           := True;
       //***********************************************************************
     End;
end;


//******************************************************************************
//     Export Entire ListView
//******************************************************************************
procedure TForm1.Button4Click(Sender: TObject);
begin
  KAExport1.TableName          := 'Employees';
  KAExport1.DataSource         := ListView1;
  KAExport1.ExportFromCurrent  := False;
  KAExport1.ExportSelected     := False;
  KAExport1.OverwriteTarget    := True;

  PageControl1.ActivePageIndex := 1;
  SaveDialog1.Filter           := KAExport1.FileFormatsList;
  SaveDialog1.DefaultExt       := 'xls';
  if SaveDialog1.Execute then
     Begin
       KAExport1.ConfigureFromFileName(SaveDialog1.FileName);
       if KAExport1.OverwriteTarget then DeleteFile(SaveDialog1.FileName);
       KAExport1.Activate := True;
     End;
end;

//******************************************************************************
//     Export ListView starting from current row (first selected row)
//******************************************************************************
procedure TForm1.Button5Click(Sender: TObject);
begin
  KAExport1.TableName          := 'Employees';
  KAExport1.DataSource         := ListView1;
  KAExport1.ExportFromCurrent  := True;
  KAExport1.ExportSelected     := False;
  KAExport1.OverwriteTarget    := True;

  PageControl1.ActivePageIndex := 1;
  SaveDialog1.Filter           := KAExport1.FileFormatsList;
  SaveDialog1.DefaultExt       := 'xls';
  if SaveDialog1.Execute then
     Begin
       KAExport1.ConfigureFromFileName(SaveDialog1.FileName);
       if KAExport1.OverwriteTarget then DeleteFile(SaveDialog1.FileName);
       KAExport1.Activate := True;
     End;
end;

//******************************************************************************
//     Export ListView selected rows only
//******************************************************************************
procedure TForm1.Button6Click(Sender: TObject);
begin
  KAExport1.TableName          := 'Employees';
  KAExport1.DataSource         := ListView1;
  KAExport1.ExportFromCurrent  := False;
  KAExport1.ExportSelected     := True;
  KAExport1.OverwriteTarget    := True;

  PageControl1.ActivePageIndex := 1;
  SaveDialog1.Filter           := KAExport1.FileFormatsList;
  SaveDialog1.DefaultExt       := 'xls';
  if SaveDialog1.Execute then
     Begin
       KAExport1.ConfigureFromFileName(SaveDialog1.FileName);
       if KAExport1.OverwriteTarget then DeleteFile(SaveDialog1.FileName);
       KAExport1.Activate := True;
     End;
end;

//******************************************************************************
//     Export Entire StringGrid
//******************************************************************************
procedure TForm1.Button7Click(Sender: TObject);
begin
  KAExport1.TableName          := 'Employees';
  KAExport1.DataSource         := StringGrid1;
  KAExport1.ExportFromCurrent  := False;
  KAExport1.ExportSelected     := False;
  KAExport1.UseFixedRows       := True;
  KAExport1.OverwriteTarget    := True;

  PageControl1.ActivePageIndex := 2;
  SaveDialog1.Filter           := KAExport1.FileFormatsList;
  SaveDialog1.DefaultExt       := 'xls';
  if SaveDialog1.Execute then
     Begin
       KAExport1.ConfigureFromFileName(SaveDialog1.FileName);
       if KAExport1.OverwriteTarget then DeleteFile(SaveDialog1.FileName);
       KAExport1.Activate := True;
     End;
end;

//******************************************************************************
//     Export StringGrid starting from current row (first selected row)
//******************************************************************************
procedure TForm1.Button8Click(Sender: TObject);
begin
  KAExport1.TableName          := 'Employees';
  KAExport1.DataSource         := StringGrid1;
  KAExport1.ExportFromCurrent  := True;
  KAExport1.ExportSelected     := False;
  KAExport1.UseFixedRows       := True;
  KAExport1.OverwriteTarget    := True;

  PageControl1.ActivePageIndex := 2;
  SaveDialog1.Filter           := KAExport1.FileFormatsList;
  SaveDialog1.DefaultExt       := 'xls';
  if SaveDialog1.Execute then
     Begin
       KAExport1.ConfigureFromFileName(SaveDialog1.FileName);
       if KAExport1.OverwriteTarget then DeleteFile(SaveDialog1.FileName);
       KAExport1.Activate := True;
     End;
end;

//******************************************************************************
//     Export StringGrid selected rows only
//******************************************************************************
procedure TForm1.Button9Click(Sender: TObject);
begin
  KAExport1.TableName          := 'Employees';
  KAExport1.DataSource         := StringGrid1;
  KAExport1.ExportFromCurrent  := False;
  KAExport1.ExportSelected     := True;
  KAExport1.UseFixedRows       := True;
  KAExport1.OverwriteTarget    := True;

  ShowMessage(IntToStr(StringGrid1.Selection.Left)+' '+IntToStr(StringGrid1.Selection.Top)+' '+IntToStr(StringGrid1.Selection.Right)+' '+IntToStr(StringGrid1.Selection.Bottom));

  PageControl1.ActivePageIndex := 2;
  SaveDialog1.Filter           := KAExport1.FileFormatsList;
  SaveDialog1.DefaultExt       := 'xls';
  if SaveDialog1.Execute then
     Begin
       KAExport1.ConfigureFromFileName(SaveDialog1.FileName);
       if KAExport1.OverwriteTarget then DeleteFile(SaveDialog1.FileName);
       KAExport1.Activate := True;
     End;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  PageControl1.ActivePageIndex := 0;
  StringGrid1.Cells[0,0] := 'ID';
  StringGrid1.Cells[1,0] := 'Last Name';
  StringGrid1.Cells[2,0] := 'First Name';
  StringGrid1.Cells[3,0] := 'Hire date';
  StringGrid1.Cells[4,0] := 'Salary';

  StringGrid1.Cells[0,1] := '1';
  StringGrid1.Cells[0,2] := '2';
  StringGrid1.Cells[0,3] := '3';
  StringGrid1.Cells[0,4] := '4';
  StringGrid1.Cells[0,5] := '5';
  StringGrid1.Cells[0,6] := '6';
  StringGrid1.Cells[0,7] := '7';
  StringGrid1.Cells[0,8] := '8';
  StringGrid1.Cells[0,9] := '9';

  StringGrid1.Cells[1,1] := 'Davolio';
  StringGrid1.Cells[1,2] := 'Fuller';
  StringGrid1.Cells[1,3] := 'Leverling';
  StringGrid1.Cells[1,4] := 'Peacock';
  StringGrid1.Cells[1,5] := 'Buchanan';
  StringGrid1.Cells[1,6] := 'Suyama';
  StringGrid1.Cells[1,7] := 'King';
  StringGrid1.Cells[1,8] := 'Callahan';
  StringGrid1.Cells[1,9] := 'Dodsworth';

  StringGrid1.Cells[2,1] := 'Nancy';
  StringGrid1.Cells[2,2] := 'Andrew';
  StringGrid1.Cells[2,3] := 'Janet';
  StringGrid1.Cells[2,4] := 'Margaret';
  StringGrid1.Cells[2,5] := 'Steven';
  StringGrid1.Cells[2,6] := 'Michael';
  StringGrid1.Cells[2,7] := 'Robert';
  StringGrid1.Cells[2,8] := 'Laura';
  StringGrid1.Cells[2,9] := 'Anne';

  StringGrid1.Cells[3,1] := '01.05.1992';
  StringGrid1.Cells[3,2] := '14.08.1992';
  StringGrid1.Cells[3,3] := '01.04.1992';
  StringGrid1.Cells[3,4] := '03.05.1993';
  StringGrid1.Cells[3,5] := '17.10.1993';
  StringGrid1.Cells[3,6] := '17.10.1993';
  StringGrid1.Cells[3,7] := '02.01.1994';
  StringGrid1.Cells[3,8] := '05.03.1994';
  StringGrid1.Cells[3,9] := '15.11.1994';

  StringGrid1.Cells[4,1] := '1000.22';
  StringGrid1.Cells[4,2] := '2000.22';
  StringGrid1.Cells[4,3] := '3000.22';
  StringGrid1.Cells[4,4] := '4000.22';
  StringGrid1.Cells[4,5] := '5000.22';
  StringGrid1.Cells[4,6] := '6000.22';
  StringGrid1.Cells[4,7] := '7000.22';
  StringGrid1.Cells[4,8] := '8000.22';
  StringGrid1.Cells[4,9] := '9000.22';
end;

//******************************************************************************
//
//     Called for each exported row of data
//     CurrentRecord is zero bazed record number
//     RecordCount is total number of records to be exported
//
//******************************************************************************
procedure TForm1.KAExport1ExportProgress(Sender: TObject; CurrentRecord, RecordCount: Integer);
begin
  ProgressBar1.Min      := 0;
  ProgressBar1.Max      := RecordCount;
  ProgressBar1.Position := CurrentRecord+1;
  ProgressBar1.Update;
  Sleep(300);
  if ProgressBar1.Position=ProgressBar1.Max then
     Begin
       ShowMessage('Export finished!');
       ProgressBar1.Position := ProgressBar1.Min;
       ProgressBar1.Update;
     End;
end;

//******************************************************************************
//
//     Called for each exported row of data
//     CurrentRecord is zero bazed record number
//     Set Export to false to prevent export of this record
//
//******************************************************************************
procedure TForm1.KAExport1ExportRow(Sender: TObject; CurrentRecord: Integer; var Export: Boolean);
begin
  Export := True;
end;

//******************************************************************************
//
//     Called for each exported row of data
//     CurrentRecord is zero bazed record number
//     RecordCount is total number of records to be exported
//
//******************************************************************************
procedure TForm1.KAExport1HeaderError(Sender: TObject; ColumnNumber: Integer;  var Header: string);
begin
//
end;

//******************************************************************************
//
//     Occurs when given TableName for export is not compatible with target
//     database format
//     For example it may contaign spaces or special characters
//     You can change it here
//
//******************************************************************************
procedure TForm1.KAExport1TableNameError(Sender: TObject; var TableName: string);
begin
//
end;

//******************************************************************************
//
//     Called for each column header if you want to inspact and change it
//     ColumnNumber indicates the field number inside dataset or column
//     number inside TListView or TStringGrid
//     Header is string containing current FieldName or Column caption
//
//******************************************************************************
procedure TForm1.KAExport1ValidateHeaders(Sender: TObject; ColumnNumber: Integer; var Header: string);
begin
//
end;

//******************************************************************************
//
//     Called for each Row and Field before exporting its data so you can
//     evaluete/ change exported data
//     CurrentRecord is zero based record number inside Dataset or Row inside
//     TListView or TStringGrid
//     FieldNumber indicates the field number inside dataset or column
//     number inside TListView or TStringGrid
//
//******************************************************************************
procedure TForm1.KAExport1ValidateValue(Sender: TObject; CurrentRecord, FieldNumber: Integer; var Value: OleVariant);
begin
//
end;

end.


